package danielcortes.xyz.views.components.table_model;

import danielcortes.xyz.models.egreso.Egreso;
import java.text.NumberFormat;
import java.util.ArrayList;
import javax.swing.table.AbstractTableModel;

public class EgresosTableModel extends AbstractTableModel {

  private String[] columns;
  private ArrayList<Egreso> rows;
  private NumberFormat nf;

  public EgresosTableModel() {
    super();
    this.columns = new String[]{"N°", "Descripcion", "Valor", "Tipo"};
    this.rows = new ArrayList<>();
    this.nf = NumberFormat.getIntegerInstance();

  }

  @Override
  public String getColumnName(int col) {
    return columns[col];
  }

  @Override
  public int getColumnCount() {
    return columns.length;
  }

  @Override
  public int getRowCount() {
    return rows.size();
  }

  @Override
  public Object getValueAt(int row, int col) {
    switch (col) {
      case 0:
        return rows.get(row).getNro();
      case 1:
        return rows.get(row).getDescripcion();
      case 2:
        return nf.format(rows.get(row).getValor());
      case 3:
        return rows.get(row).getTipoEgreso().getNombre();
    }
    return null;
  }

  public void addRow(Egreso egreso) {
    rows.add(egreso);
    this.fireTableRowsInserted(getRowCount() - 1, getRowCount() - 1);

  }

  public void removeRow(int row) {
    this.rows.remove(row);
    this.fireTableRowsDeleted(row, row);
  }

  public void removeRows() {
    int rowCount = getRowCount();
    if (rowCount > 0) {
      this.rows.clear();
      this.fireTableRowsDeleted(0, rowCount - 1);
    }
  }

  public Egreso getEgreso(int row) {
    return rows.get(row);
  }

  public void setEgreso(int editingId, Egreso egreso) {
    this.rows.set(editingId, egreso);
    this.fireTableRowsUpdated(0, getRowCount() - 1);
  }

}
